//package heuthes.hdb;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.security.KeyStore;
import java.security.cert.Certificate;
import java.util.ArrayList;
import java.util.Enumeration;

import org.eclipse.jetty.alpn.server.ALPNServerConnectionFactory;
import org.eclipse.jetty.http2.HTTP2Cipher;
import org.eclipse.jetty.http2.server.HTTP2ServerConnectionFactory;
import org.eclipse.jetty.http3.server.HTTP3ServerConnectionFactory;
import org.eclipse.jetty.http3.server.HTTP3ServerConnector;
import org.eclipse.jetty.server.ConnectionFactory;
import org.eclipse.jetty.server.Connector;
import org.eclipse.jetty.server.Handler;
import org.eclipse.jetty.server.HttpConfiguration;
import org.eclipse.jetty.server.HttpConnectionFactory;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.SecureRequestCustomizer;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.ServerConnector;
import org.eclipse.jetty.server.SslConnectionFactory;
import org.eclipse.jetty.server.handler.ContextHandler;
import org.eclipse.jetty.server.handler.DefaultHandler;
import org.eclipse.jetty.server.handler.HandlerList;
import org.eclipse.jetty.server.handler.ResourceHandler;
import org.eclipse.jetty.util.ssl.SslContextFactory;
import org.eclipse.jetty.util.thread.QueuedThreadPool;

import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

class www_srv_config
	{
	public static boolean use_http3 = false;

	public static String key_store_type = "JKS";
	public static String key_store = "keystore/hdb_keystore.ks";
	public static String key_store_passwd = "heuthes_hdb";
	static String cert_alias = "stresstest.heuthesd's heuthes sp. z o.o. id";
	static String trust_key_store_type = "JKS";
	static String trust_key_store = "keystore/hdb_keystore.ks";
	static String trust_key_store_passwd = "heuthes_hdb";
	static String key_passwd = "heuthes_hdb";
	}



class HDB_jetty_handler_test extends ResourceHandler
	{
	static int REQ_NR = 0;

	@Override
	public void handle(String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
		{
		++REQ_NR;
		try
			{
			response.setStatus(200);
			response.setContentType("text/plain");
			PrintWriter pw = response.getWriter();
			pw.write("request " + REQ_NR + "\n");
			pw.close();
			baseRequest.setHandled(true);
			}
		catch (Exception e)
			{
			System.err.println("Problem with " + target);
			e.printStackTrace();
			response.sendError(500, e.toString());
			}
		}

	}



public class jetty_srv_test
	{
	static private ArrayList<Server> jetty_servers = new ArrayList<Server>();

	static void https_log(final String s)
		{
		System.out.println(s);
		} // https_log

	static final String MAX_AGE = "max-age=" + (1 * 3600);
	static String RESOURCE_BASE = "";

	static Server getJettyServer()
		{
		QueuedThreadPool thp = new QueuedThreadPool();
		thp.setMinThreads(10);
		thp.setMaxThreads(50);
		thp.setStopTimeout(180000);
		thp.setIdleTimeout(60000);
		return new Server(thp);
		} // configureThreadPool



	static private void set_jetty_handlers(Server server)
		{
		ResourceHandler resource_handler = new HDB_jetty_handler_test();
		resource_handler.setDirectoriesListed(false);
		resource_handler.setWelcomeFiles(new String[] { "index.html" });
		resource_handler.setResourceBase("/var/www/html/");
		resource_handler.setCacheControl(MAX_AGE);

		// I want to work with aliases (links and symbolic links)
		ContextHandler context_handler = new ContextHandler();
		//context_handler.addAliasCheck(new ApproveAllAliases());

		HandlerList handlers = new HandlerList();
		handlers.setHandlers(new Handler[] { resource_handler, new DefaultHandler() });
		context_handler.setHandler(handlers);

		server.setHandler(context_handler);
		} // set_jetty_handlers



	static boolean startHTTPSServer(int http2_port)
		{
		boolean result = false;
		try
			{
			int http3_port = http2_port + 1;
			String info = "=============== HTTP/2 (jetty) server starting on port " + http2_port;
			https_log(info);
			Server jetty_server = getJettyServer();
			System.out.println("Jetty " + jetty_server.getClass().getPackage().getImplementationVersion());

			SslContextFactory.Server sslContextFactory = null;

			sslContextFactory = new org.eclipse.jetty.util.ssl.SslContextFactory.Server();
			sslContextFactory.setKeyStorePath(www_srv_config.key_store);
			sslContextFactory.setKeyStoreType(www_srv_config.key_store_type);
			if (www_srv_config.cert_alias != null && www_srv_config.cert_alias.length() > 0)
				sslContextFactory.setCertAlias(www_srv_config.cert_alias);
			sslContextFactory.setKeyStorePassword(www_srv_config.key_store_passwd);

			sslContextFactory.setTrustStoreType(www_srv_config.trust_key_store_type);
			sslContextFactory.setTrustStorePath(www_srv_config.trust_key_store);
			sslContextFactory.setTrustStorePassword(www_srv_config.trust_key_store_passwd);

			sslContextFactory.setCipherComparator(HTTP2Cipher.COMPARATOR);

			ServerConnector SSLconnector;
			HTTP3ServerConnector http3_connector = null;
			// http://stackoverflow.com/questions/25035063/how-to-run-jetty-with-spdy-using-alpn/
			HttpConfiguration httpConfig = new HttpConfiguration();
			httpConfig.setSendServerVersion(false);
			httpConfig.addCustomizer(new SecureRequestCustomizer());

			SslConnectionFactory ssl = new SslConnectionFactory(sslContextFactory, "alpn");
			ALPNServerConnectionFactory alpn = new ALPNServerConnectionFactory("h2");
			alpn.setDefaultProtocol("http/1.1");
			HTTP2ServerConnectionFactory http2 = new HTTP2ServerConnectionFactory(httpConfig);
			HttpConnectionFactory http = new HttpConnectionFactory(httpConfig);

			SSLconnector = new ServerConnector(jetty_server, new ConnectionFactory[] { ssl, alpn, http2, http });
			if (www_srv_config.use_http3)
				{
				SslContextFactory.Server sslContextFactoryHTTP3 = new SslContextFactory.Server();
				sslContextFactoryHTTP3.setKeyStorePath(www_srv_config.key_store);
				sslContextFactoryHTTP3.setKeyStorePassword(www_srv_config.key_store_passwd);

				https_log("Create and configure the HTTP/3 connector.");
				http3_connector = new HTTP3ServerConnector(jetty_server, sslContextFactoryHTTP3, new HTTP3ServerConnectionFactory(httpConfig));
				http3_connector.setPort(http3_port);
				https_log("HTTP/3: port: " + http3_port);
				}
			SSLconnector.setPort(http2_port);
			SSLconnector.setIdleTimeout(60000);

			// register the connector
			jetty_server.setConnectors(new Connector[] { SSLconnector });
			if (http3_connector != null)
				{
				https_log("HTTP/3 adding connector...");
				jetty_server.addConnector(http3_connector);
				https_log("HTTP/3 connector added");
				info = "=============== HTTP/3 (jetty) server starting on port " + http3_port;
				https_log(info);
				}
			jetty_server.setStopTimeout(30000);
			https_log("cert alias: " + sslContextFactory.getCertAlias());
			set_jetty_handlers(jetty_server);

			jetty_servers.add(jetty_server);
			jetty_server.start();
			result = true;
			}
		catch (Exception e)
			{
			e.printStackTrace();
			https_log("Problem while starting HTTPS jetty server:" + e);
			}
		return result;
		} // startHTTPSServer



	static KeyStore testKeyStore(String title, String fname, String key_store_type, String key_store_passwd) throws Exception
		{
		System.out.println(title);
		System.out.println("file: " + fname);
		System.out.println("type: " + key_store_type);
		File file = new File(fname);
		FileInputStream is = new FileInputStream(file);
		KeyStore keystore = KeyStore.getInstance(KeyStore.getDefaultType());
		keystore.load(is, key_store_passwd.toCharArray());

		Enumeration<String> enumeration = keystore.aliases();
		while (enumeration.hasMoreElements())
			{
			String alias = enumeration.nextElement();
			System.out.println("alias name: " + alias);
			//Certificate certificate = keystore.getCertificate(alias);
			//System.out.println(certificate.toString());
			}
		System.out.println("<<<" + fname + "\n\n");
		return keystore;
		}



	static void testConfig() throws Exception
		{
		testKeyStore("KeyStore", www_srv_config.key_store, www_srv_config.key_store_type, www_srv_config.key_store_passwd);
		}



	public static void main(String[] args)
		{
		https_log("Java version: " + System.getProperty("java.version"));
		https_log("class path: " + System.getProperty("java.class.path", "."));
		for (String s: args)
			if (s.equalsIgnoreCase("--http3"))
				www_srv_config.use_http3 = true;

		https_log("use HTTP/3: " + www_srv_config.use_http3);
		if (!www_srv_config.use_http3)
			https_log("to use HTTP/3 add command line option: -http3\n\n");

		try
			{
			testConfig();
			}
		catch (Exception e1)
			{
			e1.printStackTrace();
			return;
			}

		if (startHTTPSServer(8765))
			{
			https_log("server started, press Ctrl-C to stop it...");
			while (true)
				{
				try
					{
					Thread.sleep(1000);
					}
				catch (InterruptedException e)
					{
					e.printStackTrace();
					}
				}
			}
		}

	}
